(function() {"use strict";var __module = CC_EDITOR ? module : {exports:{}};var __filename = 'preview-scripts/assets/component/ScrollNumber.js';var __require = CC_EDITOR ? function (request) {return cc.require(request, require);} : function (request) {return cc.require(request, __filename);};function __define (exports, require, module) {"use strict";
cc._RF.push(module, 'd4aecf+3sBH7Z48VE0Z04JH', 'ScrollNumber', __filename);
// component/ScrollNumber.ts

Object.defineProperty(exports, "__esModule", { value: true });
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var ScrollNumber = /** @class */ (function (_super) {
    __extends(ScrollNumber, _super);
    function ScrollNumber() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.label = null;
        _this.minNum = 0;
        _this.maxNum = 9;
        _this.rollSpeed = 300;
        _this.rollRound = 1;
        _this.speed = 300;
        _this.isAutoRoll = true;
        // 当前显示数字
        _this.curNum = 0;
        // @property({tooltip:`默认选中数字索引,索引范围 0~`}) //${this.maxMum - this.minNum + 1}
        _this.curNumIdx = 0;
        //播放时间
        _this.time = 0;
        //播放总时间
        _this.totalTime = 0;
        // label 行高
        _this.lineHeight = 0;
        // label 总高度
        _this.totalHeight = 0;
        // lable 行数
        _this.totalNum = 0;
        // 加速度
        _this.av = 0;
        _this.rolling = false;
        return _this;
    }
    ScrollNumber.prototype.onLoad = function () {
        this.initLabel();
        this.updateLabel();
    };
    ScrollNumber.prototype.setLabel = function (min, max) {
        this.minNum = min;
        this.maxNum = max;
        this.initLabel();
    };
    ScrollNumber.prototype.initLabel = function () {
        var labelStr = '';
        var count = this.maxNum - this.minNum;
        for (var i = this.minNum; i <= this.maxNum; i++) {
            labelStr += i + '\n';
        }
        labelStr += this.minNum;
        this.label.string = labelStr;
        this.lineHeight = this.label.lineHeight;
        this.label.node.parent.height = this.lineHeight;
        this.totalNum = count + 2;
        this.label.node.height = this.totalNum * this.lineHeight;
        this.totalHeight = this.label.node.height;
        var idx = this.getCurNumIdx(this.curNum);
        if (idx) {
            this.curNumIdx = idx;
        }
        // this.time = this.curNumIdx / this.speed;
    };
    ScrollNumber.prototype.getCurNumIdx = function (num) {
        for (var i = this.minNum; i < this.maxNum; i++) {
            if (num == i) {
                return i - this.minNum;
            }
        }
    };
    ScrollNumber.prototype.getCurNum = function () {
        var num = Math.round(this.curNumIdx);
        if (num >= this.maxNum - this.minNum + 1) {
            num = 0;
        }
        return num + this.minNum;
    };
    /**
     * 根据 数字显示当前
     */
    ScrollNumber.prototype.updateLabel = function () {
        this.label.node.y = this.getCurNumPositionY(this.curNum);
    };
    ScrollNumber.prototype.getCurNumPositionY = function (num) {
        var numIdx = this.getCurNumIdx(num);
        var showPosY = (numIdx - (this.totalNum - 1) * this.label.node.anchorY) * this.lineHeight;
        var y = showPosY - (0.5 - this.label.node.anchorY) * this.label.node.height;
        return y;
    };
    ScrollNumber.prototype.getCurNumByPosY = function (y) {
        var showPosY = y + (0.5 - this.label.node.anchorY) * this.label.node.height;
        this.curNumIdx = showPosY / this.lineHeight + (this.totalNum - 1) * this.label.node.anchorY;
        return this.getCurNum();
    };
    ScrollNumber.prototype.updateLabel2 = function (s) {
        var diffY = this.label.node.y + s - this.getLastPos();
        if (diffY > 0) {
            this.label.node.y = this.getStartPos() + diffY;
        }
        else {
            this.label.node.y += s;
        }
        this.curNum = this.getCurNumByPosY(this.label.node.y);
        this.curNumIdx = this.getCurNumIdx(this.curNum);
    };
    ScrollNumber.prototype.getLastPos = function () {
        var y = (this.totalNum * this.label.node.anchorY - 0.5) * this.lineHeight;
        return y;
    };
    ScrollNumber.prototype.getStartPos = function () {
        var y = -(this.totalNum * this.label.node.anchorY - 0.5) * this.lineHeight;
        return y;
    };
    ScrollNumber.prototype.scrollTo = function (num) {
        if (this.rolling) {
            return;
        }
        var idx = this.getCurNumIdx(num);
        if (null == num || null == idx) {
            return;
        }
        cc.log('rdm', num);
        this.isAutoRoll = false;
        this.speed = this.rollSpeed;
        this.time = 0;
        this.rolling = true;
        // let a = this.speed / t;
        var height = (this.totalNum - 1) * this.lineHeight;
        var diffY = this.label.node.y - this.getCurNumPositionY(this.curNum);
        var roundLeft = (this.totalNum - 1 - (this.curNumIdx + 1)) * this.lineHeight - diffY;
        var s = height * this.rollRound + (idx + 1) * this.lineHeight + roundLeft;
        this.totalTime = (s * 2) / this.speed;
        this.av = -this.speed / this.totalTime;
    };
    ScrollNumber.prototype.update = function (dt) {
        if (!this.isAutoRoll || this.speed == 0) {
            if (!this.rolling) {
                return;
            }
            this.time += dt;
            if (this.time >= this.totalTime) {
                dt -= (this.time - this.totalTime);
                this.rolling = false;
            }
            var s = this.speed * dt + this.av * dt * dt * 0.5;
            this.updateLabel2(s);
            this.speed += this.av * dt;
            return;
        }
        else {
            var s = this.rollSpeed * dt;
            this.updateLabel2(s);
        }
    };
    __decorate([
        property({ tooltip: '数字显示区', type: cc.Label })
    ], ScrollNumber.prototype, "label", void 0);
    __decorate([
        property({ tooltip: '最小滚动值' })
    ], ScrollNumber.prototype, "minNum", void 0);
    __decorate([
        property({ tooltip: '最大滚动值' })
    ], ScrollNumber.prototype, "maxNum", void 0);
    __decorate([
        property({ tooltip: '数字滚动速度' })
    ], ScrollNumber.prototype, "rollSpeed", void 0);
    __decorate([
        property({ tooltip: '滚动完当前圈后再次多滚动的圈' })
    ], ScrollNumber.prototype, "rollRound", void 0);
    __decorate([
        property({ tooltip: '自动滚动开关' })
    ], ScrollNumber.prototype, "isAutoRoll", void 0);
    __decorate([
        property({ tooltip: '当前显示的数字`${maxMum}`' })
    ], ScrollNumber.prototype, "curNum", void 0);
    ScrollNumber = __decorate([
        ccclass
    ], ScrollNumber);
    return ScrollNumber;
}(cc.Component));
exports.default = ScrollNumber;

cc._RF.pop();
        }
        if (CC_EDITOR) {
            __define(__module.exports, __require, __module);
        }
        else {
            cc.registerModuleFunc(__filename, function () {
                __define(__module.exports, __require, __module);
            });
        }
        })();
        //# sourceMappingURL=ScrollNumber.js.map
        